#ifndef SENDBUTTONMENU_H
#define SENDBUTTONMENU_H

#include <QDialog>
#include <QMenu>
#include <QPointer>
#include <QSignalMapper>

#include "ui_sendbuttontemplateseditor.h"

class SendButtonTemplatesEditor : public QDialog
{
	Q_OBJECT
public:
	SendButtonTemplatesEditor(QWidget* parent = 0);

private:
	Ui::SendButtonTemplatesEditor ui_;
	//QString t;
	QAction *editAction;
	QAction *removeAction;
	QAction *upAction;
	QAction *downAction;
	void swapItem(int);

private slots:
	void addTemplate();
	void removeTemplate();
	void editTemplate();
	void upTemplate();
	void downTemplate();
	void selectionChanged();
	void contextMenu(QPoint);

protected slots:
	void accept();

};

class SendButtonTemplatesMenu : public QMenu
{
	Q_OBJECT
public:
	SendButtonTemplatesMenu(QWidget* parent);
	void setParams(bool ps);

private:
	QSignalMapper *mapper;
	bool ps_;
	QAction *pasteSendAct;
	QAction *onlyPaste;
	void updatePsAction();

private slots:
	void update();
	void clickOnlyPaste();
	void optionChanged(const QString& option);

signals:
	void doPasteAndSend();
	void doEditTemplates();
	void doTemplateText(const QString &);

};

#endif
